#!/usr/bin/perl

#Jan 22, 2004: Completed Date
#Developer:  Lucky J. Winebarger
#United States Postal Service
#Jan 10, 2007: Updated Date
#Modify to include another extraction fields

use sigtrap 'handler' => \&myhand, 'INT';
use File::Basename;

&setup;
use Cwd; 
chdir("$home/bin"); 
&checkop;


#main Menu#--------------
while (1)
{
	&clear;
	&title;
	
	$type  = &promptUser("1 - Extraction - unzip for unix \n2 - File format \n3 - Quit \n");
	
	if ($type == 1 || $type eq "e")
	{
		&checkzip;
		&decrypt;
		&unzip;
	}
	elsif($type == 2 || $type eq "f")
	{
		&pre_config;
		
		while (not $true)
		{
			&format;
			&selection;
		}
	}
	elsif($type == 3 || $type eq "q")
	{
		print ("\n");
		exit 0;
	}
	else{}
}

#-------------------------------------------------#
#Check for unzip application
#-------------------------------------------------#
sub checkzip
{
	if (not $zipverify eq "true")
	{
		print ("\n\nWait... while we check zip status\n");
		print ("[ Ctrl+C and check $unzip if prompt never return ]\n");
		
		my $status = qx!$unzip -version! or die
		"Cannot find unzip application\nPlease setup your environment variables\n";
		$zipverify = "true";
	}
}

#--------------------(setup information)-----------------------------#
#--------------------------------------------------------------------#
sub setup
{
	$config_file = "$ENV{'HOME'}/.cds_config";
	
	if ( -e $config_file )
	{
		open(inf, "< $config_file");
		
		while(<inf>)
		{
			chop($_);
			($w_name,$w_info)=split(/=/,$_);
			($w_res)=split(/ /,$w_info);
			$$w_name = "$w_res";
		}
		
		close(inf);
		
		if ($unzip eq "")
		{
			$unzip = "pkzip";
		}
		
		if ($algorithm eq "")
		{
			$algorithm = "AES,128";
		}
	}
	else
	{
		print("**Please run configure.pl to setup environment**\n");
		exit 1;
	}
}

#------------------------------------------------------------#
#Check for os-operation
#------------------------------------------------------------#
sub checkop
{
	my $opSys = $^O;
	
	if ($opSys eq "solaris" || $opSys eq "linux")
	{
		sub title {print("\tCDS Conversion Software for Unix 2.0\n");
				   print("\t  (United States Postal Services)\n\n");
				   print("**************************************************************\n");
				   print("OS:  $opSys\n");
				   print("**************************************************************\n"); }
		
		sub clear
		{
			system("clear");
		}
		
		&clear;
		&title;
	}
	else
	{
		print("Incompatible Version of OS\n");
		exit 1;
	}
}

#---------------------(To Selection)--------------------------------------------------#
#Selection for format features	                                                      #
#-------------------------------------------------------------------------------------#	
sub selection
{
$select = &promptUser(
"1[Line feed] \t\t3[sPlit zip] \t\t4[Ams delivery]\n
v[Volume Out] \t\tz[Zip Out] \t\tc[Carrier Out]\n
d[Delivery Out] \t5[Justify street name] \tr[Reset]\n
8[subMit] \t\ts[Save]\t\t\t9[Quit]\n\n\n");
	
	if ($select == 9 || $select eq "q")
	{
		last;
	}
	
	if ($select eq "r")
	{
		&pre_config;
	}
	
	if ($select eq "s")
	{
		&save_config;
	}
	
	if ($select == 1 || $select eq "l")
	{
		if ($line_feed eq "yes")
		{
			$line_feed = "no";
			$delimiter = "no";
		}
		elsif ($delimiter eq "no" && $line_feed eq "no")
		{
			$line_feed = "none";
			$delimiter = "yes";
		}
		else
		{
			$line_feed = "yes";
			$delimiter = "no";
		}
	}
	
	#if ($select == 2 || $select eq "d")
	#{
	#	if ($delimiter eq "yes")
	# 	{
	#		$delimiter = "no";
	#	}
	#  	else
	#	{
	#		$delimiter = "yes";
	#	}
	#}
	
	if ($select == 3 || $select eq "p")
	{
		if ($split_zip eq "yes")
		{
			$split_zip = "no";
		}
		else
		{
			$split_zip = "yes";
		}
	}
	
	#if ($select == 3 || $select eq "p")
	#{
	#	if ($split_zip eq "3")
	#	{
	#		$split_zip = "1";
	#	}
	#	elsif
	#	(
	#		$split_zip eq "5";
	#	)
	#	{
	#		$split_zip = "3";
	#	}
	# 	else
	#	{
	#		$split_zip = "5";
	#	}
	#}
	
	if ($select == 4 || $select eq "a")
	{
		if ($ams_delivery eq "yes")
		{
			$ams_delivery = "no";
		}
		else
		{
			$ams_delivery = "yes";
		}
	}
	
	if ($select == 5 || $select eq "j")
	{
		if ($justify_street eq "yes")
		{
			$justify_street = "no";
		}
		else
		{
			$justify_street = "yes";
		}
	}
	
	if ($select eq "v")
	{
		if ($volume eq "yes")
		{
			$volume = "no";
		}
		else
		{
			$volume = "yes";
		}
	}
	
	if ($select eq "z")
	{
		if ($zip eq "yes")
		{
			$zip = "no";
		}
		else
		{
			$zip = "yes";
		}
	}
	
	if ($select eq "c")
	{
		if ($carrier eq "yes")
		{
			$carrier = "no";
		}
		else
		{
			$carrier = "yes";
		}
	}
	
	if ($select eq "d")
	{
		if ($delivery eq "yes")
		{
			$delivery = "no";
		}
		else
		{
			$delivery = "yes";
		}
	}
	
	if ($select == 8 || $select eq "m")
	{
		&submit;
	}
}

#---------------------(Save Configuration from menu)---------------------#
#check for configure files else create                                   #
#------------------------------------------------------------------------#	
sub save_config
{
	chdir("$home/etc");
	$config_file = "$ENV{'HOME'}/.cds_pre";
	
	if (-e $config_file)
	{
		unlink $config_file;
	}
	
	if (-e $config_file)
	{
		open(logfile, ">> ../log/main.log");
		print logfile "permission denied to write to .cds_pre\n";
		close(logfile);
	}
	
	if (not -e $config_file)
	{
		open(ouf, "> $config_file");
		print ouf "line_feed=$line_feed #[yes, no or none]\n";
		print ouf "delimiter=$delimiter #[yes or no]\n";
		print ouf "split_zip=$split_zip #[yes or no]\n";
		print ouf "ams_delivery=$ams_delivery #[yes or no]\n";
		print ouf "justify_street=$justify_street #[yes or no]\n";
		print ouf "volume=$volume #[yes or no]\n";
		print ouf "zip=$zip #[yes or no]\n";
		print ouf "carrier=$carrier #[yes or no]\n";
		print ouf "delivery=$delivery #[yes or no]\n";
		close(ouf);
		
		open(logfile, ">> ../log/main.log");
		print logfile "save new config to .cds_pre\n";
		close(logfile);
	}
}

#---------------------(Predefined Configure Files)-----------------------#
#check for configure files else create                                   #
#------------------------------------------------------------------------#	
sub pre_config
{
	chdir("$home/etc");
	$config_file = "$ENV{'HOME'}/.cds_pre";
	
	if (not -e $config_file)
	{
		open(ouf, "> $config_file");
		print ouf "line_feed=yes #[yes, no or none]\n";
		print ouf "delimiter=no #[yes or no]\n";
		print ouf "split_zip=no #[yes or no]\n";
		print ouf "ams_delivery=yes #[yes or no]\n";
		print ouf "justify_street=yes #[yes or no]\n";
		print ouf "volume=no #[yes or no]\n";
		print ouf "zip=yes #[yes or no]\n";
		print ouf "carrier=yes #[yes or no]\n";
		print ouf "delivery=yes #[yes or no]\n";
		close(ouf);
		
		open(logfile, ">> ../log/main.log");
		print logfile "create new .cds_pre\n";
		close(logfile);
	}
	
	if (-e $config_file && -r $config_file)
	{
		open(inf, "< $config_file");
		
		while(<inf>)
		{
			chop($_);
			($w_name,$w_info)=split(/=/,$_);
			($w_res)=split(/ /,$w_info);
			$$w_name = "$w_res";
		}
		
		close(inf);
		
		if ($line_feed eq ""){$line_feed = "yes"}
		if ($delimiter eq ""){$delimiter = "no"}
		if ($split_zip eq ""){$split_zip = "no"}
		if ($ams_delivery eq ""){$ams_delivery = "yes"}
		if ($justify_street eq ""){$justify_street = "yes"}
		if ($volume eq ""){$volume = "no"}
		if ($zip eq ""){$zip = "yes"}
		if ($carrier eq ""){$carrier = "yes"}
		if ($delivery eq ""){$delivery = "yes"}
	}	
}

#---------------------(To Format)-----------------------------------------------------#
#Format Features                                                                      #
#-------------------------------------------------------------------------------------#	
sub format
{
	chdir("$home/outfiles");
	&clear;
	
	print("================================== CDS Options =======================\n\n");
	print("  Destination Directory:     $home/outfiles  \n\n");
	
	print("          Output Format:     (");
	if ($line_feed eq "yes")
	{
		print("*");
	}
	else
	{
		print(" ");
	}
	
	print(") Fixed Record Length(CR/LF)\n");
	
	print("                             (");
	if ($line_feed eq "no")
	{
		print("*");
	}
	else
	{
		print(" ");
	}
	
	print(") Fixed Record Length(No CR/LF)\n");
	
	print("                             (");
	if ($delimiter eq "yes")
	{
		print("*");
	}
	else
	{
		print(" ");
	}
	
	print(") Comma Delimited\n\n");
	print("Split Files by ZIP Code:     (");
	
	if ($split_zip eq "yes")
	{
		print("*");
	}
	else
	{
		print(" ");
	}
	
	print(") Yes\n");
	print("                             (");
	
	if ($split_zip eq "no")
	{
		print("*");
	}
	else
	{
		print(" ");
	}
	
	print(") No\n\n");
	#print("                             (");
	#if ($split_zip eq "3")
	#{
	#	print("*");
	#}
	#else
	#{
	#	print(" ");
	#}
	
	#print(") ZIP3\n");
	#print("                             (");
	#if ($split_zip eq "1")
	#{
	#	print("*");
	#}
	#else
	#{
	#	print(" ");
	#}
	
	#print(") ZIP1\n\n");
	
	print("     USPS Field Formats:     (");
	
	if ($ams_delivery eq "yes")
	{
		print("*");
	}
	else
	{
		print(" ");
	}
	
	print(") AMS style delivery numbers\n");
	print("                             (");
	
	if ($justify_street eq "yes")
	{
		print("*");
	}
	else
	{
		print(" ");
	}
	
	print(") Justified Street Name\n\n");
	print("    Output Record Types:     (");
	
	if ($volume eq "yes")
	{
		print("*");
	}
	else
	{
		print(" ");
	}
	
	print(") Volume\n");
	print("                             (");
	
	if ($zip eq "yes")
	{
		print("*");
	}
	else
	{
		print(" ");
	}
	
	print(") ZIP Code\n");
	print("                             (");
	
	if ($carrier eq "yes")
	{
		print("*");
	}
	else
	{
		print(" ");
	}
	
	print(") Carrier Route\n");
	print("                             (");
	
	if ($delivery eq "yes")
	{
		print("*");
	}
	else
	{
		print(" ");
	}
	
	print(") Delivery Point\n\n");
	print("================================== CDS Options =======================\n\n");
}


#---------------------(To Submit)------------------------------------------------------#
#Submit Features                                                                       #
#-------------------------------------------------------------------------------- -----#
sub submit
{
	chdir("$home/infiles");
	opendir(DIR, "../infiles");
	@cds = grep(/\.[cC][dD][sS]$/,readdir(DIR));
	closedir(DIR);
	
	opendir(DIR, "../infiles");
	@wcd = grep(/\.[wW][cC][dD]$/,readdir(DIR));
	closedir(DIR);
	
	&clear;
	my $cont = 0;
        my $answer = '';
	
	foreach $file (@cds)
	{
		$cont = 1;
		$answer = &promptUser("\nDo you want to convert this Monthly CDS file: '$file' [y,n,q] ","n");
		
		if ($answer eq "q")
		{
			last;
		}
        elsif ($answer eq "y")
        {
        	$name = &promptUser("\nEnter output name prefix","cds","norm");
        	my $convert_result = qx! ../bin/convert.pl $file $name $line_feed $delimiter $split_zip $ams_delivery $justify_street $volume $zip $carrier $delivery!;
        	&clear;
        	print("cds conversion successfully");
        	sleep 2;
        }
        else{}
	}
	
		foreach $file (@wcd)
		{
		        if ($answer eq "q")
                        {
                                last;
                        }

			$cont = 1;
			$answer = &promptUser("\nDo you want to convert this Weekly CDS file: '$file' [y,n,q] ","n");
			
			if ($answer eq "q")
			{
				last;
			}
			elsif ($answer eq "y")
			{
				$name = &promptUser("\nEnter output name prefix","cds","norm");
				my $convert_result = qx! ../bin/convert.pl $file $name $line_feed $delimiter $split_zip $ams_delivery $justify_street $volume $zip $carrier $delivery!;
				&clear;
				print("wcd conversion successfully");
				sleep 2;
			}
			else{}
		}
    
    if ($cont == 0)
    {
    	print("\n**no file available to convert**");
    	sleep 1;
    }  
}

#---------------------(To Unzip)----------------------------------------#
#Unzip Features                                                         #
#-----------------------------------------------------------------------#	
sub unzip
{
	if ($password eq "")
	{
		promptUser("Please enter password to decrypt","","","password");
	}
	
	chdir("$home/infiles");
   	opendir(DIR, "../infiles");
	@files = grep(/\.zip$/,readdir(DIR));
	#closedir(DIR);
	&clear;
	$exiss = "no";
	
	my $fileName = "";
	my $filePath = "";
	my $fileSuffix = "";
	
	# After unzipping files, move *.CDE and *.zip files to ../archive directory
	my $archiveDir = "$home/archive";
	if(not -e $archiveDir)
	{
		my $retVal = mkdir $archiveDir, 0744;
		
		if($retVal != 1)
		{
			print("Warning : could not create $home/archive/ directory\n");
		}
	}
	
	foreach $file (@files)
 	{
 		$exiss = "yes";
 		$answer = &promptUser("\nDo you want to unzip this file: '$file' [y,n,q]","n");
 		
 		if ($answer eq "q")
 		{
 			last;
 		}
 		elsif ($answer eq "y")
 		{
 			print("    wait.....");
 			my $unzip_result = qx!$unzip -extract -pass="$password" -cryptalgorithm="$algorithm" $file!;
 			print($unzip_result);
 			
 			if ($unzip_result =~ /Inflating/)
 			{
 				&clear;
 				print("   unzip successful");
 				
 				# Move the *.zip file to the archive directory.
 				system("mv $file $archiveDir/.");
 				
 				# Move the *.cde (or *.CDE) file to the archive directory. 				
 				($fileName, $filePath, $fileSuffix) = fileparse($file, ".zip");
 				
 				if(-e "$fileName.cde")
 				{
					system("mv \"$fileName.cde\" $archiveDir/.");
 				}
 				else
 				{
 					if(-e "$fileName.CDE")
 					{
 						system("mv \"$fileName.CDE\" $archiveDir/.");
 					}
 				}
 			}
 			
 			sleep 2;
 		}
 		else{}
 	}
	
	closedir(DIR);

	if ($exiss eq "no")
	{
		print("\n**no file available to unzip");
		sleep 1;
	}
}

#---------------------(To decrypt)----------------------------------------------------#
#decryption features                                                                  #
#-------------------------------------------------------------------------------------#	
sub decrypt
{
	chdir("$home/infiles");
   	opendir(DIR, "../infiles");
	@files = grep(/\.cde$/,readdir(DIR));
	closedir(DIR);
    &clear;
    
    my $decryptString = "1212 ";
	my $param= "";
	my $decryptApp = "$home/bin/des ";
	my $fileName = "";
	my $filePath = "";
	my $fileSuffix = "";
	
	foreach $file (@files) # lowercase file extension (*.cde)
	{
		($fileName, $filePath, $fileSuffix) = fileparse($file, ".cde");
        $param = "$decryptApp $decryptString ../infiles/$file $fileName.zip";
        
        my $retVal = system ("$param");
    }
	
	opendir(DIR, "../infiles");
	@files = grep(/\.CDE$/,readdir(DIR));
	closedir(DIR);
    &clear;
    
    foreach $file (@files) # uppercase file extension (*.CDE)
	{
		($fileName, $filePath, $fileSuffix) = fileparse($file, ".CDE");
       $param = "$decryptApp $decryptString ../infiles/$file $fileName.zip";
        
        my $retVal = system ("$param");
    }
}

#----------------------------(  promptUser  )-----------------------------#
#                                                                         #
#  FUNCTION:	promptUser                                                #
#                                                                         #
#  PURPOSE:	Prompt the user for some type of input, and return the    #
#		input back to the calling program.                        #
#                                                                         #
#  ARGS:	$promptString - what you want to prompt the user with     #
#		$defaultValue - (optional) a default value for the prompt #
#                                                                         #
#-------------------------------------------------------------------------#

sub promptUser
{
	#-------------------------------------------------------------------#
	#  two possible input arguments - $promptString, and $defaultValue  #
	#  make the input arguments local variables.                        #
	#-------------------------------------------------------------------#
	
	local($promptString,$defaultValue,$normal,$passwd) = @_;
	
	#-------------------------------------------------------------------#
	#  if there is a default value, use the first print statement; if   #
	#  no default is provided, print the second string.                 #
	#-------------------------------------------------------------------#
	
	if ($defaultValue)
	{
		if ($passwd)
		{
			&clear;
		}
		
		print $promptString, "[", $defaultValue, "]:>> ";
	}
	else
	{
		if ($passwd)
		{
			&clear;
		}
		
		print $promptString, ":>> ";
	}
	
	$| = 1;               # force a flush after our print
	
	if ($normal)
	{
		$_ = <STDIN>;         # get the input from STDIN (presumably the keyboard)
	}
	elsif ($passwd)
	{
		while (1)
		{
			system "stty", '-icanon', 'eol', "\001";
			$_ = getc(STDIN);         # get the input from STDIN (presumably the keyboard)
			
			if ($_ eq "\n")
			{
				last;
			}
			else
			{
				&clear;
				$star = $star."*";
				print $promptString." :>>".$star;
				$password = $password.$_;
			}
			
			system "stty", 'icanon','eol','^@';
		}
	}
	else
	{
		system "stty", '-icanon', 'eol', "\001";
		$_ = getc(STDIN);         # get the input from STDIN (presumably the keyboard)
		system "stty", 'icanon','eol','^@';
	}
	
	#------------------------------------------------------------------#
	# remove the newline character from the end of the input the user  #
	# gave us.                                                         #
	#------------------------------------------------------------------#
	
	chomp;
	
	#-----------------------------------------------------------------#
	#  if we had a $default value, and the user gave us input, then   #
	#  return the input; if we had a default, and they gave us no     #
	#  no input, return the $defaultValue.                            #
	#                                                                 # 
	#  if we did not have a default value, then just return whatever  #
	#  the user gave us.  if they just hit the <enter> key,           #
	#  the calling routine will have to deal with that.               #
	#-----------------------------------------------------------------#
	
	if ("$defaultValue")
	{
		return $_ ? $_ : $defaultValue;    # return $_ if it has a value
	}
	else
	{
		return $_;
	}
}
