#!/usr/bin/perl

#------------------------------------------------------------#
#Check for os-operation
#------------------------------------------------------------#
my $opSys = $^O;

if ($opSys eq "solaris" || $opSys eq "linux")
{
  sub title{
  print("\tCDS Conversion Software Configuration for Unix 2.0\n");
  print("\t\t(United States Postal Services)\n\n");
  print("*******************************************************************\n");
  print("<CTRL + C> to stop anytime\n");
  print("*******************************************************************\n");}

  sub clear { system("clear");  }
  &clear;
  &title;}
else
{  print("Incompatible Version of OS"); exit 0;}


#------------------------------------------------------------------------------
#Main Body
#-------------------------------------------------
&pre_config;
#-------------------------------------------------


sub pre_config {
  $config_file = "$ENV{'HOME'}/.cds_config";
  if (not -e $config_file)
  {
   open(ouf, "> $config_file");

   while (not -e $vfy){ 
   $input = &promptUser("Enter CDS Home","/home/cds","norm"); 
   $vfy = $input."/bin/cds.pl";
    if (not -e $vfy){print("CDS Home does not exist\n");}}
   print ouf "home=$input\n";

   &promptUser("Enter Unzip Password","","","password");
   print ouf "password=$pass\n";

   while (not $status){
   $input = &promptUser("Enter Unzip Tool","pkzip","norm");
   $status = qx!$input -version!;
    if (not $status){print("Cannot Find Unzip Tool\n");}}
   print ouf "unzip=$input\n";

   $input = &promptUser("Enter Crypt Algorithm","AES,128","norm");
   print ouf "algorithm=$input\n";

   print("**CDS conversion is ready to use**\n"); sleep 3;
   close(ouf);

   open(logfile, ">> ../log/main.log"); 
   print logfile "cds conversion is ready to use\n"; 
   close(logfile);
  }
  else
  {
   open(inf, "< $config_file");
   while(<inf>)
   {
     chop($_);
     ($w_name,$w_info)=split(/=/,$_);
     ($w_res)=split(/ /,$w_info);
     $$w_name = "$w_res";
   }close(inf);
  
   if ($home eq ""){$home = "/home/cds";}
   if ($unzip eq ""){$unzip = "pkzip";}
   if ($algorithm eq ""){$algorithm = "AES,128";}
   open(ouf, "> $config_file");

   while (not -e $vfy){
   $input = &promptUser("Enter CDS Home","$home","norm"); 
   $vfy = $input."/bin/cds.pl";
    if (not -e $vfy){print("CDS Home does not exist\n"); }}
   print ouf "home=$input\n";

   &promptUser("Enter Unzip Password","","","password");
   print ouf "password=$pass\n";

   while (not $status){
   $input = &promptUser("Enter Unzip Tool","$unzip","norm");
   $status = qx!$input -version!;
    if (not $status){print("Cannot Find Unzip Tool\n"); }}
   print ouf "unzip=$input\n";

   $input = &promptUser("Enter Crypt Algorithm","$algorithm","norm");
   print ouf "algorithm=$input\n";

   print("**CDS conversion is ready to use**\n"); sleep 3;
   close(ouf);

   open(logfile, ">> ../log/main.log");
   print logfile "setup.pre is modified to use\n";
   close(logfile); 
  }}

	
#----------------------------(  promptUser  )-----------------------------#
#                                                                         #
#  FUNCTION:    promptUser                                                #
#                                                                         #
#  PURPOSE:     Prompt the user for some type of input, and return the    #
#               input back to the calling program.                        #
#                                                                         #
#  ARGS:        $promptString - what you want to prompt the user with     #
#               $defaultValue - (optional) a default value for the prompt #
#                                                                         #
#-------------------------------------------------------------------------#

sub promptUser {

   #-------------------------------------------------------------------#
   #  two possible input arguments - $promptString, and $defaultValue  #
   #  make the input arguments local variables.                        #
   #-------------------------------------------------------------------#

   local($promptString,$defaultValue,$normal,$password) = @_;

   #-------------------------------------------------------------------#
   #  if there is a default value, use the first print statement; if   #
   #  no default is provided, print the second string.                 #
   #-------------------------------------------------------------------#

   if ($defaultValue) {
     if ($password){&clear};
      print $promptString, "[", $defaultValue, "]:>> ";
   } else {
     if ($password){&clear};
      print $promptString, ":>> ";
   }

   $| = 1;               # force a flush after our print


   if ($normal){
    system("stty erase ^?");
    $_ = <STDIN>;         # get the input from STDIN (presumably the keyboard)
   }

  elsif ($password)
   {
    while (1){
    system "stty", '-icanon', 'eol', "\001";
    $_ = getc(STDIN);         # get the input from STDIN (presumably the keyboard)
    if ($_ eq "\n")
    {last;}
    else{
     &clear;
     $star = $star."*";
     print $promptString." :>>".$star;
     $pass = $pass.$_;
    }
    system "stty", 'icanon','eol','^@';}
   }

   else{
   system "stty", '-icanon', 'eol', "\001";
   $_ = getc(STDIN);         # get the input from STDIN (presumably the keyboard)
   system "stty", 'icanon','eol','^@';
   }


   #------------------------------------------------------------------#
   # remove the newline character from the end of the input the user  #
   # gave us.                                                         #
   #------------------------------------------------------------------#

   chomp;

   #-----------------------------------------------------------------#
   #  if we had a $default value, and the user gave us input, then   #
   #  return the input; if we had a default, and they gave us no     #
   #  no input, return the $defaultValue.                            #
   #                                                                 #
   #  if we did not have a default value, then just return whatever  #
   #  the user gave us.  if they just hit the <enter> key,           #
   #  the calling routine will have to deal with that.               #
   #-----------------------------------------------------------------#

   if ("$defaultValue") {
      return $_ ? $_ : $defaultValue;    # return $_ if it has a value
   } else {
      return $_;
   }
}

