#!/usr/bin/perl

&setup;
use Cwd;
chdir("$home/infiles");

my $infile = $ARGV[0], $name = $ARGV[1], $line_feed = $ARGV[2], $delimiter = $ARGV[3], $split_zip = $ARGV[4], 
$ams_delivery = $ARGV[5], $justify_street = $ARGV[6], $volume = $ARGV[7], $zip = $ARGV[8], $carrier = $ARGV[9], $delivery = $ARGV[10];

if ($infile eq '')
{ print("Require cds convertion file to continue\n"); exit 1; }

if ($name eq '')
{ $name = "cds"; }

$mcd = grep(/\.[Cc][Dd][Ss]$/,$infile);
$wcd = grep(/\.[Ww][Cc][Dd]$/,$infile);
if ($wcd == 0  and $mcd == 0){print("This is not Weekly/Monthly CDS file\n");exit 1;}


open(inf, "< $infile") or die "Unable to open $infile\n"; 

if (not $ARGV[2])
{
  chdir("$home/etc");
  $config_file = "$ENV{'HOME'}/.cds_pre";

  if (-e $config_file && -r $config_file)
  {
   open(conf, "< $config_file");
   while(<conf>)
   {
     chop($_);
     ($w_name,$w_info)=split(/=/,$_);
     ($w_res)=split(/ /,$w_info);
     $$w_name = "$w_res";
   }
   close(conf);
   if ($line_feed eq ""){$line_feed = "yes"}
   if ($delimiter eq ""){$delimiter = "no"}
   if ($split_zip eq ""){$split_zip = "no"}
   if ($ams_delivery eq ""){$ams_delivery = "yes"}
   if ($justify_street eq ""){$justify_street = "yes"}
   if ($volume eq ""){$volume = "no"}
   if ($zip eq ""){$zip = "yes"}
   if ($carrier eq ""){$carrier = "yes"}
   if ($delivery eq ""){$delivery = "yes"}
  }
}
elsif (not $ARGV[10])
{ print("**You do not provide enough information**\n"); exit 0; }
else{}

chdir("$home/infiles");
binmode(inf);


while($buf = <inf>)
{
 &monthly; &weekly;
}
close(inf);


#--------------------------(Monthly CDS)-----------------------------#
######################################################################
sub monthly {
  if ($mcd == 1)
  {
   $indicator = substr($buf,0,1);
   if ($indicator == 1 && $volume eq "yes")
   { &header_mo; }
   elsif ($indicator == 2 && $zip eq "yes")
   { &zip_mo; }
   elsif ($indicator == 3 && $carrier eq "yes")
   { &carrier_mo; }
   elsif ($indicator == 4 && $delivery eq "yes")
   { &delivery_mo;}
   else{}
   
    
 sub header_mo
 {
  $mailerid = substr($buf,1,9);
  $month = substr($buf,10,2);
  $dash = substr($buf,12,1);
  $year = substr($buf,13,2);
  $vol = substr($buf,15,3);
  $zip_cnt = substr($buf,18,5);
  $route_cnt = substr($buf,23,7);
  $tot_cnt = substr($buf,30,9);
  $filler = substr($buf,39,67);
  if ($delimiter eq "yes"){ $c = ","; }else{ $c = ""; }
  if ($line_feed eq "yes" || $line_feed eq "none"){ $feed = "\n"; }else{ $feed = ""; }

  if ($zip eq "no" && $carrier eq "no" && $delivery eq "no")
  {$file = "../outfiles/".$name."_volume";
  open(ouf, "> $file") or die "Unable to open $file\n";

  if ($delimiter eq "yes")
  {
  print ouf "\"$indicator\",\"$mailerid\",\"$month\",\"$dash\",\"$year\",\"$vol\",$zip_cnt,$route_cnt,$tot_cnt$feed"; close(ouf);
  }else{
  print ouf "$indicator$mailerid$month$dash$year$vol$zip_cnt$route_cnt$tot_cnt$filler$feed"; close(ouf);
  }}

  if ($delimiter eq "yes")
  {
  $volume_count = "\"$indicator\",\"$mailerid\",\"$month\",\"$dash\",\"$year\",\"$vol\",$zip_cnt,$route_cnt,$tot_cnt$feed";
  }else{
  $volume_count = "$indicator$mailerid$month$dash$year$vol$zip_cnt$route_cnt$tot_cnt$filler$feed";
  }}


 sub zip_mo {
  if ($split_zip eq "yes")
  {
   $file = "../outfiles/".$name.substr($buf,6,5);
  }
  else
  {$file = "../outfiles/".$name;}

  if (not $$file){
  open(ouf, "> $file") or die "Unable to open $file\n";
  }else{
  open(ouf, ">> $file") or die "Unable to open $file\n";
  }

  $month = substr($buf,1,2);
  $dash = substr($buf,3,1);
  $year = substr($buf,4,2);
  $zipcode = substr($buf,6,5);
  $route_cnt = substr($buf,11,5);
  $del_cnt = substr($buf,16,5);
  $adel_cnt = substr($buf,21,5);
  $pdel_cnt = substr($buf,26,5);
  $badel_cnt = substr($buf,31,5);
  $bpdel_cnt = substr($buf,36,5);
  $po_cnt = substr($buf,41,4);
  $season_cnt = substr($buf,45,5);
  $vacant_cnt = substr($buf,50,5);
  $drop_cnt = substr($buf,55,5);
  $rdrop_cnt = substr($buf,60,5);
  $filler = substr($buf,65,41);
  if ($delimiter eq "yes"){ $c = ","; }else{ $c = ""; }
  if ($line_feed eq "yes" || $line_feed eq "none"){ $feed = "\n"; }else{ $feed = ""; }

  if (not $$file){ if ($volume eq "yes"){print ouf $volume_count;} $$file = "go"; }
  
  if ($delimiter eq "yes")
  {
  print ouf "\"$indicator\",\"$month\",\"$dash\",\"$year\",\"$zipcode\",$route_cnt,$del_cnt,$adel_cnt,$pdel_cnt,$badel_cnt,$bpdel_cnt,$po_cnt,$season_cnt,$vacant_cnt,$drop_cnt,$rdrop_cnt$feed";
  close(ouf);
  }else{
  print ouf $indicator.$month.$dash.$year.$zipcode.$route_cnt.$del_cnt.$adel_cnt.$pdel_cnt.$badel_cnt.$bpdel_cnt.$po_cnt.$season_cnt.$vacant_cnt.$drop_cnt.$rdrop_cnt.$filler.$feed;
  close(ouf);}}


 sub carrier_mo {
   if ($split_zip eq "yes")
  {
   $file = "../outfiles/".$name.substr($buf,1,5);
  }
  else
  {$file = "../outfiles/".$name;}

  if (not $$file){
  open(ouf, "> $file") or die "Unable to open $file\n";
  }else{
  open(ouf, ">> $file") or die "Unable to open $file\n";
  }

  $zipcode = substr($buf,1,5);
  $route_id = substr($buf,6,4);
  $del_cnt = substr($buf,10,5);
  $adel_cnt = substr($buf,15,5);
  $pdel_cnt = substr($buf,20,5);
  $badel_cnt = substr($buf,25,5);
  $bpdel_cnt = substr($buf,30,5);
  $po_cnt = substr($buf,35,3);
  $season_cnt = substr($buf,38,5);
  $vacant_cnt = substr($buf,43,5);
  $drop_cnt = substr($buf,48,5);
  $rdrop_cnt = substr($buf,53,5);
  $filler = substr($buf,58,48);
  if ($delimiter eq "yes"){ $c = ","; }else{ $c = ""; }
  if ($line_feed eq "yes" || $line_feed eq "none"){ $feed = "\n"; }else{ $feed = ""; }

  if (not $$file){ if ($volume eq "yes"){print ouf $volume_count;} $$file = "go"; }

  if ($delimiter eq "yes")
  {
  print ouf "\"$indicator\",\"$zipcode\",\"$route_id\",$del_cnt,$adel_cnt,$pdel_cnt,$badel_cnt,$bpdel_cnt,$po_cnt,$season_cnt,$vacant_cnt,$drop_cnt,$rdrop_cnt$feed";
  close(ouf);
  }else
  {
  print ouf $indicator.$zipcode.$route_id.$del_cnt.$adel_cnt.$pdel_cnt.$badel_cnt.$bpdel_cnt.$po_cnt.$season_cnt.$vacant_cnt.$drop_cnt.$rdrop_cnt.$filler.$feed;
  close(ouf);
  }} 

 sub delivery_mo {
   if ($split_zip eq "yes")
  {
   $file = "../outfiles/".$name.substr($buf,1,5);
  }
  else
  {$file = "../outfiles/".$name;}

  if (not $$file){
  open(ouf, "> $file") or die "Unable to open $file\n";
  }else{
  open(ouf, ">> $file") or die "Unable to open $file\n";
  }

  $zipcode = substr($buf,1,5);
  $route_id = substr($buf,6,4);
  $del_nbr = substr($buf,10,5);
  $rec_code = substr($buf,15,1);
  $po_ind = substr($buf,16,1);

  $del_adr_nbr = substr($buf,17,10);
  if ($ams_delivery eq "no")
  {
   $first = substr($del_adr_nbr,0,1);
   if ($first eq "-")
   {
     $del_adr_nbr = "0".substr($buf,18,9);
   }
   else 
   {  
	for (my $num == 0; $num < 10; $num++)
        {
         $up = substr($del_adr_nbr,0,1);
         if ($up eq " " || $up == 0)
         {
          $del_adr_nbr = substr($del_adr_nbr,1,9); 
	   }
         else{ last; }}
  	 $del_adr_nbr =~ s/\s+$//;
         $len = length($del_adr_nbr); while ($len < 10) { $del_adr_nbr = " ".substr($del_adr_nbr,0,9); $len = length($del_adr_nbr); }

   }
  }

  $str_pre = substr($buf,27,2);

  $str_name = substr($buf,29,28);
  if ($justify_street eq "no"){
   for (my $loop = 1; $loop < 28; $loop++)
   {
     $up=substr($str_name,0,1);
       if ($up eq " ")
       {
        $str_name = substr($str_name,1,27)." "; 
       }
       else{last;}     
   }}

  $str_suf = substr($buf,57,4);
  $str_post = substr($buf,61,2);
  $secadr_abb = substr($buf,63,4);

  $secadr_nbr = substr($buf,67,8);
  if ($ams_delivery eq "no")
  {
  $first = substr($secadr_nbr,0,1);
  if ($first eq "-")
  {
   $secadr_nbr = "0".substr($buf,68,7);
  }
  else
   {
        for (my $num == 0; $num < 8; $num++)
        {
         $up = substr($secadr_nbr,0,1);
         if ($up eq " " || $up == 0)
         {
          $secadr_nbr = substr($secadr_nbr,1,7); }
         else{last;}}
  	 $secadr_nbr =~ s/\s+$//;
         $len = length($secadr_nbr); while ($len < 8) { $secadr_nbr = " ".substr($secadr_nbr,0,7); $len = length($secadr_nbr); }
   }
  }

  $del_type = substr($buf,75,1);
  $adr_ind = substr($buf,76,1);
  $del_drp_ind = substr($buf,77,1);
  $del_bus = substr($buf,78,3);
  $season_ind = substr($buf,81,1);
  $plus4_sec = substr($buf,82,2);
  $plus4_seg = substr($buf,84,2);
  $del_digit = substr($buf,86,2);
  $del_cdigit = substr($buf,88,1);
  $urban = substr($buf,89,6);
  $last = substr($buf,95,6);
  $fillerx = substr($buf,101,1);
  $doc = substr($buf,102,1);
  $filler = substr($buf,103,3);
  if ($delimiter eq "yes"){ $c = ","; }else{ $c = ""; }
  if ($line_feed eq "yes" || $line_feed eq "none"){ $feed = "\n"; }else{ $feed = ""; }

  if (not $$file){ if ($volume eq "yes"){print ouf $volume_count;} $$file = "go"; }

  if ($delimiter eq "yes")
  {
  $indicator =~ s/^\s+//;
  $indicator =~ s/\s+$//;
  $zipcode =~ s/^\s+//;
  $zipcode =~ s/\s+$//;
  $route_id =~ s/^\s+//;
  $route_id =~ s/\s+$//;
  $del_nbr =~ s/^\s+//;
  $del_nbr =~ s/\s+$//;
  $rec_code =~ s/^\s+//;
  $rec_code =~ s/\s+$//;
  $po_ind =~ s/^\s+//;
  $po_ind =~ s/\s+$//;
  $del_adr_nbr =~ s/^\s+//;
  $del_adr_nbr =~ s/\s+$//;
  $str_pre =~ s/^\s+//;
  $str_pre =~ s/\s+$//;
  $str_name =~ s/^\s+//;
  $str_name =~ s/\s+$//;
  $str_suf =~ s/^\s+//;
  $str_suf =~ s/\s+$//;
  $str_post =~ s/^\s+//;
  $str_post =~ s/\s+$//;
  $secadr_abb =~ s/^\s+//;
  $secadr_abb =~ s/\s+$//;
  $secadr_nbr =~ s/^\s+//;
  $secadr_nbr =~ s/\s+$//;
  $del_type =~ s/^\s+//;
  $del_type =~ s/\s+$//;
  $adr_ind =~ s/^\s+//;
  $adr_ind =~ s/\s+$//;
  $del_drp_ind =~ s/^\s+//;
  $del_drp_ind =~ s/\s+$//;
  $del_bus =~ s/^\s+//;
  $del_bus =~ s/\s+$//;
  $season_ind =~ s/^\s+//;
  $season_ind =~ s/\s+$//;
  $plus4_sec =~ s/^\s+//;
  $plus4_sec =~ s/\s+$//;
  $plus4_seg =~ s/^\s+//;
  $plus4_seg =~ s/\s+$//;
  $del_digit =~ s/^\s+//;
  $del_digit =~ s/\s+$//;
  $del_cdigit =~ s/^\s+//;
  $del_cdigit =~ s/\s+$//;
  $urban =~ s/^\s+//;
  $urban =~ s/\s+$//;
  $filler =~ s/^\s+//;
  $filler =~ s/\s+$//;
  $last =~ s/^\s+//;
  $last =~ s/\s+$//;
  $doc =~ s/^\s+//;
  $doc =~ s/\s+$//;
  $fillerx =~ s/^\s+//;
  $fillerx =~ s/\s+$//;

  print ouf "\"$indicator\",\"$zipcode\",\"$route_id\",\"$del_nbr\",\"$rec_code\",\"$po_ind\",\"$del_adr_nbr\",\"$str_pre\",\"$str_name\",\"$str_suf\",\"$str_post\",\"$secadr_abb\",\"$secadr_nbr\",\"$del_type\",\"$adr_ind\",\"$del_drp_ind\",\"$del_bus\",\"$season_ind\",\"$plus4_sec$plus4_seg\",\"$del_digit\",\"$del_cdigit\",\"$urban\",\"$last\",\"$doc\"$feed";
  close(ouf);
  }else{
  print ouf $indicator.$zipcode.$route_id.$del_nbr.$rec_code.$po_ind.$del_adr_nbr.$str_pre.$str_name.$str_suf.$str_post.$secadr_abb.$secadr_nbr.$del_type.$adr_ind.$del_drp_ind.$del_bus.$season_ind.$plus4_sec.$plus4_seg.$del_digit.$del_cdigit.$urban.$last.$fillerx.$doc.$filler.$feed;
  close(ouf);
 }}

}}


sub weekly {

 if ($wcd == 1)
  {
   $indicator = substr($buf,0,1);
   if ($indicator == 1 && $volume eq "yes")
   { &header; }
   elsif ($indicator == 2 && $zip eq "yes")
   { &zip; }
   elsif ($indicator == 3 && $carrier eq "yes")
   { &carrier; }
   elsif ($indicator == 4 && $delivery eq "yes")
   { &delivery;}
   else{}


 sub header
 {
  $mailerid = substr($buf,1,13);
  $month = substr($buf,14,2);
  $dash = substr($buf,16,1);
  $year = substr($buf,17,4);
  $dash2 = substr($buf,21,1);
  $vol = substr($buf,22,2);
  $zip_cnt = substr($buf,24,5);
  $route_cnt = substr($buf,29,7);
  $tot_cnt = substr($buf,36,9);
  $filler = substr($buf,45,61);
  if ($delimiter eq "yes"){ $c = ","; }else{ $c = ""; }
  if ($line_feed eq "yes" || $line_feed eq "none"){ $feed = "\n"; }else{ $feed = ""; }

  if ($zip eq "no" && $carrier eq "no" && $delivery eq "no")
  {$file = "../outfiles/".$name."_volume";
  open(ouf, "> $file") or die "Unable to open $file\n";

   if ($delimiter eq "yes")
  {
  print ouf "\"$indicator\",\"$mailerid\",\"$month\",\"$dash\",\"$year\",\"$dash2\",\"$vol\",$zip_cnt,$route_cnt,$tot_cnt$feed"; close(ouf);
  }else{
  print ouf "$indicator$mailerid$month$dash$year$dash2$vol$zip_cnt$route_cnt$tot_cnt$filler$feed"; close(ouf);
  }}

  if ($delimiter eq "yes")
  {
  $volume_count = "\"$indicator\",\"$mailerid\",\"$month\",\"$dash\",\"$year\",\"$dash2\",\"$vol\",$zip_cnt,$route_cnt,$tot_cnt$feed";
  }else{
  $volume_count = "$indicator$mailerid$month$dash$year$dash2$vol$zip_cnt$route_cnt$tot_cnt$filler$feed";
  }}

 sub zip {
   if ($split_zip eq "yes")
  {
   $file = "../outfiles/".$name.substr($buf,11,5);
  }
  else
  {$file = "../outfiles/".$name;}

  if (not $$file){
  open(ouf, "> $file") or die "Unable to open $file\n";
  }else{
  open(ouf, ">> $file") or die "Unable to open $file\n";
  }

  $month = substr($buf,1,2);
  $dash = substr($buf,3,1);
  $year = substr($buf,4,4);
  $dash2 = substr($buf,8,1);
  $dd = substr($buf,9,2);
  $zipcode = substr($buf,11,5);
  $route_cnt = substr($buf,16,5);
  $del_cnt = substr($buf,21,5);
  $adel_cnt = substr($buf,26,5);
  $pdel_cnt = substr($buf,31,5);
  $badel_cnt = substr($buf,36,5);
  $bpdel_cnt = substr($buf,41,5);
  $po_cnt = substr($buf,46,4);
  $season_cnt = substr($buf,50,5);
  $vacant_cnt = substr($buf,55,5);
  $drop_cnt = substr($buf,60,5);
  $rdrop_cnt = substr($buf,65,5);
  $filler = substr($buf,70,36);
  if ($delimiter eq "yes"){ $c = ","; }else{ $c = ""; }
  if ($line_feed eq "yes" || $line_feed eq "none"){ $feed = "\n"; }else{ $feed = ""; }

  if (not $$file){ if ($volume eq "yes"){print ouf $volume_count;} $$file = "go"; }

  if ($delimiter eq "yes")
  {
  print ouf "\"$indicator\",\"$month\",\"$dash\",\"$year\",\"$dash2\",\"$dd\",\"$zipcode\",$route_cnt,$del_cnt,$adel_cnt,$pdel_cnt,$badel_cnt,$bpdel_cnt,$po_cnt,$season_cnt,$vacant_cnt,$drop_cnt,$rdrop_cnt$feed";
  close(ouf);
  }else{
  print ouf $indicator.$month.$dash.$year.$dash2.$dd.$zipcode.$route_cnt.$del_cnt.$adel_cnt.$pdel_cnt.$badel_cnt.$bpdel_cnt.$po_cnt.$season_cnt.$vacant_cnt.$drop_cnt.$rdrop_cnt.$filler.$feed;
  close(ouf);}}


  sub carrier {
   if ($split_zip eq "yes")
  {
   $file = "../outfiles/".$name.substr($buf,1,5);
  }
  else
  {$file = "../outfiles/".$name;}

  if (not $$file){
  open(ouf, "> $file") or die "Unable to open $file\n";
  }else{
  open(ouf, ">> $file") or die "Unable to open $file\n";
  }

  $zipcode = substr($buf,1,5);
  $route_id = substr($buf,6,4);
  $del_cnt = substr($buf,10,5);
  $adel_cnt = substr($buf,15,5);
  $pdel_cnt = substr($buf,20,5);
  $badel_cnt = substr($buf,25,5);
  $bpdel_cnt = substr($buf,30,5);
  $po_cnt = substr($buf,35,3);
  $season_cnt = substr($buf,38,5);
  $vacant_cnt = substr($buf,43,5);
  $drop_cnt = substr($buf,48,5);
  $rdrop_cnt = substr($buf,53,5);
  $filler = substr($buf,58,48);
  if ($delimiter eq "yes"){ $c = ","; }else{ $c = ""; }
  if ($line_feed eq "yes" || $line_feed eq "none"){ $feed = "\n"; }else{ $feed = ""; }

  if (not $$file){ if ($volume eq "yes"){print ouf $volume_count;} $$file = "go"; }

  if ($delimiter eq "yes")
  {
  print ouf "\"$indicator\",\"$zipcode\",\"$route_id\",$del_cnt,$adel_cnt,$pdel_cnt,$badel_cnt,$bpdel_cnt,$po_cnt,$season_cnt,$vacant_cnt,$drop_cnt,$rdrop_cnt$feed";
  close(ouf);
  }else
  {
  print ouf $indicator.$zipcode.$route_id.$del_cnt.$adel_cnt.$pdel_cnt.$badel_cnt.$bpdel_cnt.$po_cnt.$season_cnt.$vacant_cnt.$drop_cnt.$rdrop_cnt.$filler.$feed;
  close(ouf);
  }}


  sub delivery {
   if ($split_zip eq "yes")
  {
   $file = "../outfiles/".$name.substr($buf,1,5);
  }
  else
  {$file = "../outfiles/".$name;}

  if (not $$file){
  open(ouf, "> $file") or die "Unable to open $file\n";
  }else{
  open(ouf, ">> $file") or die "Unable to open $file\n";
  }

  $zipcode = substr($buf,1,5);
  $route_id = substr($buf,6,4);
  $del_nbr = substr($buf,10,5);
  $rec_code = substr($buf,15,1);
  $po_ind = substr($buf,16,1);

  $del_adr_nbr = substr($buf,17,10);
  if ($ams_delivery eq "no")
  {
  $first = substr($del_adr_nbr,0,1);
  if ($first eq "-")
  {
   $del_adr_nbr = "0".substr($buf,18,9);
  }
  else
   {
	for (my $cwtt == 0; $cwtt < 10; $cwtt++)
        {
         $up = substr($del_adr_nbr,0,1);
         if ($up eq " " || $up == 0)
         {
          $del_adr_nbr = substr($del_adr_nbr,1,9)." "; }
         else{last;}}
  	 $del_adr_nbr =~ s/\s+$//;
         $len = length($del_adr_nbr); while ($len < 10) { $del_adr_nbr = " ".substr($del_adr_nbr,0,9); $len = length($del_adr_nbr); }
         
    }
  }

  $str_pre = substr($buf,27,2);

  $str_name = substr($buf,29,28);
  if ($justify_street eq "no"){
   for (my $loop = 1; $loop < 28; $loop++)
   {
     $up=substr($str_name,0,1);
       if ($up eq " ")
       {
        $str_name = substr($str_name,1,27)." ";
       }
       else{last;}
   }}

  $str_suf = substr($buf,57,4);
  $str_post = substr($buf,61,2);
  $secadr_abb = substr($buf,63,4);

  $secadr_nbr = substr($buf,67,8);
  if ($ams_delivery eq "no")
  {
  $first = substr($secadr_nbr,0,1);
  if ($first eq "-")
  {
   $secadr_nbr = "0".substr($buf,68,7);
  }
  else
   {
	for (my $cid == 0; $cid < 8; $cid++)
        {
         $up = substr($secadr_nbr,0,1);
         if ($up eq " " || $up == 0)
         {
          $secadr_nbr = substr($secadr_nbr,1,7)." "; }
         else{last;}}
  	 $secadr_nbr =~ s/\s+$//;
         $len = length($secadr_nbr); while ($len < 8) { $secadr_nbr = " ".substr($secadr_nbr,0,7); $len = length($secadr_nbr); }
    }
  }

  $del_type = substr($buf,75,1);
  $adr_ind = substr($buf,76,1);
  $del_drp_ind = substr($buf,77,1);
  $del_bus = substr($buf,78,3);
  $season_ind = substr($buf,81,1);
  $plus4_sec = substr($buf,82,2);
  $plus4_seg = substr($buf,84,2);
  $del_digit = substr($buf,86,2);
  $del_cdigit = substr($buf,88,1);
  $urban = substr($buf,89,6);
  $last = substr($buf,95,6);
  $fillerx = substr($buf,101,1);
  $doc = substr($buf,102,1);
  $filler = substr($buf,103,3);
  if ($delimiter eq "yes"){ $c = ","; }else{ $c = ""; }
  if ($line_feed eq "yes" || $line_feed eq "none"){ $feed = "\n"; }else{ $feed = ""; }

  if (not $$file){ if ($volume eq "yes"){print ouf $volume_count;} $$file = "go"; }

  if ($delimiter eq "yes")
  {
  $indicator =~ s/^\s+//;
  $indicator =~ s/\s+$//;
  $zipcode =~ s/^\s+//;
  $zipcode =~ s/\s+$//;
  $route_id =~ s/^\s+//;
  $route_id =~ s/\s+$//;
  $del_nbr =~ s/^\s+//;
  $del_nbr =~ s/\s+$//;
  $rec_code =~ s/^\s+//;
  $rec_code =~ s/\s+$//;
  $po_ind =~ s/^\s+//;
  $po_ind =~ s/\s+$//;
  $del_adr_nbr =~ s/^\s+//;
  $del_adr_nbr =~ s/\s+$//;
  $str_pre =~ s/^\s+//;
  $str_pre =~ s/\s+$//;
  $str_name =~ s/^\s+//;
  $str_name =~ s/\s+$//;
  $str_suf =~ s/^\s+//;
  $str_suf =~ s/\s+$//;
  $str_post =~ s/^\s+//;
  $str_post =~ s/\s+$//;
  $secadr_abb =~ s/^\s+//;
  $secadr_abb =~ s/\s+$//;
  $secadr_nbr =~ s/^\s+//;
  $secadr_nbr =~ s/\s+$//;
  $del_type =~ s/^\s+//;
  $del_type =~ s/\s+$//;
  $adr_ind =~ s/^\s+//;
  $adr_ind =~ s/\s+$//;
  $del_drp_ind =~ s/^\s+//;
  $del_drp_ind =~ s/\s+$//;
  $del_bus =~ s/^\s+//;
  $del_bus =~ s/\s+$//;
  $season_ind =~ s/^\s+//;
  $season_ind =~ s/\s+$//;
  $plus4_sec =~ s/^\s+//;
  $plus4_sec =~ s/\s+$//;
  $plus4_seg =~ s/^\s+//;
  $plus4_seg =~ s/\s+$//;
  $del_digit =~ s/^\s+//;
  $del_digit =~ s/\s+$//;
  $del_cdigit =~ s/^\s+//;
  $del_cdigit =~ s/\s+$//;
  $urban =~ s/^\s+//;
  $urban =~ s/\s+$//;
  $filler =~ s/^\s+//;
  $filler =~ s/\s+$//;
  $last =~ s/^\s+//;
  $last =~ s/\s+$//;
  $doc =~ s/^\s+//;
  $doc =~ s/\s+$//;
  $fillerx =~ s/^\s+//;
  $fillerx =~ s/\s+$//;

   print ouf "\"$indicator\",\"$zipcode\",\"$route_id\",\"$del_nbr\",\"$rec_code\",\"$po_ind\",\"$del_adr_nbr\",\"$str_pre\",\"$str_name\",\"$str_suf\",\"$str_post\",\"$secadr_abb\",\"$secadr_nbr\",\"$del_type\",\"$adr_ind\",\"$del_drp_ind\",\"$del_bus\",\"$season_ind\",\"$plus4_sec$plus4_seg\",\"$del_digit\",\"$del_cdigit\",\"$urban\",\"$last\",\"$doc\"$feed";
  close(ouf);
  }else{
  print ouf $indicator.$zipcode.$route_id.$del_nbr.$rec_code.$po_ind.$del_adr_nbr.$str_pre.$str_name.$str_suf.$str_post.$secadr_abb.$secadr_nbr.$del_type.$adr_ind.$del_drp_ind.$del_bus.$season_ind.$plus4_sec.$plus4_seg.$del_digit.$del_cdigit.$urban.$last.$fillerx.$doc.$filler.$feed;
  close(ouf);
 }}

}}

#--------------------(setup information)-----------------------------#
#--------------------------------------------------------------------#
sub setup {
 $config_file = "$ENV{'HOME'}/.cds_config";
 if ( -e $config_file ){
 open(inf, "< $config_file");
   while(<inf>)
   {
     chop($_);
     ($w_name,$w_info)=split(/=/,$_);
     ($w_res)=split(/ /,$w_info);
     $$w_name = "$w_res";
   }close(inf);
   if ($unzip eq ""){$unzip = "pkzip";}
   if ($algorithm eq ""){$algorithm = "AES,128";}
 }
 else { print("**Please run configure.pl to setup environment**\n"); exit 1; }
}
